## net.sf.saxon.pattern
Class CombinedNodeTest

    java.lang.Object
      |
      +--net.sf.saxon.pattern.NodeTest
            |
            +--net.sf.saxon.pattern.CombinedNodeTest

All Implemented Interfaces:
  ItemType, java.io.Serializable

public class CombinedNodeTest
extends NodeTest

A CombinedNodeTest combines two nodetests using one of the operators union (=or), intersect (=and), difference (= "and not"). This arises when optimizing a union (etc) of two path expressions using the same axis. A CombinedNodeTest is also used to support constructs such as element(N,T), which can be expressed as (element(N,*) AND element(*,T))

See Also:
  Serialized Form

Constructor Summary
`CombinedNodeTest(NodeTest nt1, int operator, NodeTest nt2)`

Method Summary
`boolean` `allowsTextNodes()` Indicate whether this NodeTest is capable of matching text nodes
`SchemaType` `getContentType()` Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
`double` `getDefaultPriority()` get the default priority of this nodeTest when used as a pattern
`int` `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
`java.util.Set` `getRequiredNodeNames()` Get the set of node names allowed by this NodeTest.
`int` `hashCode()` Returns a hash code value for the object.
`boolean` `matches(int nodeType, int fingerprint, int annotation)` Test whether this node test is satisfied by a given node.
`boolean` `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
`java.lang.String` `toString()`

Methods inherited from class net.sf.saxon.pattern.NodeTest
`getAtomizedItemType, getFingerprint, getPrimitiveItemType, getPrimitiveType, getSuperType, matchesItem, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CombinedNodeTest

    public CombinedNodeTest(NodeTest nt1,
                            int operator,
                            NodeTest nt2)

Method Detail

### matches

    public boolean matches(int nodeType,
                           int fingerprint,
                           int annotation)

  Test whether this node test is satisfied by a given node.

  Specified by:
    `matches` in class `NodeTest`
  Parameters:
    `nodeType` - The type of node to be matched
    `fingerprint` - identifies the expanded name of the node to be matched. The value should be -1 for a node with no name.
    `annotation` - The actual content type of the node

### matches

    public boolean matches(NodeInfo node)

  Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.

  Specified by:
    `matches` in class `NodeTest`
  Parameters:
    `node` - the node to be matched

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### allowsTextNodes

    public boolean allowsTextNodes()

  Indicate whether this NodeTest is capable of matching text nodes

  Specified by:
    `allowsTextNodes` in class `NodeTest`

### getNodeKindMask

    public int getNodeKindMask()

  Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<<Type.ELEMENT for element nodes, 1<<Type.TEXT for text nodes, and so on.

  Specified by:
    `getNodeKindMask` in class `NodeTest`

### getRequiredNodeNames

    public java.util.Set getRequiredNodeNames()

  Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. A null value indicates that all names are permitted (i.e. that there are no constraints on the node name. The default implementation returns null.

  Overrides:
    `getRequiredNodeNames` in class `NodeTest`

### getContentType

    public SchemaType getContentType()

  Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.

  Overrides:
    `getContentType` in class `NodeTest`

### hashCode

    public int hashCode()

  Returns a hash code value for the object.

  Overrides:
    `hashCode` in class `java.lang.Object`

### getDefaultPriority

    public double getDefaultPriority()

  get the default priority of this nodeTest when used as a pattern

  Specified by:
    `getDefaultPriority` in class `NodeTest`